import { setMaxListeners } from '@libp2p/interface';
import { anySignal } from 'any-signal';
export function createTimeoutOptions(timeout, ...existingSignals) {
    let signal = AbortSignal.timeout(timeout);
    setMaxListeners(Infinity, signal);
    if (existingSignals.length > 0) {
        signal = anySignal([signal, ...existingSignals]);
        setMaxListeners(Infinity, signal);
    }
    return {
        signal
    };
}
//# sourceMappingURL=abort-options.js.map