import { type ClearableSignal } from 'any-signal';
import type { Metrics } from '@libp2p/interface';
export declare const DEFAULT_TIMEOUT_MULTIPLIER = 1.2;
export declare const DEFAULT_FAILURE_MULTIPLIER = 2;
export declare const DEFAULT_MIN_TIMEOUT = 2000;
export interface AdaptiveTimeoutSignal extends ClearableSignal {
    start: number;
    timeout: number;
}
export interface AdaptiveTimeoutInit {
    metricName?: string;
    metrics?: Metrics;
    interval?: number;
    initialValue?: number;
    timeoutMultiplier?: number;
    failureMultiplier?: number;
    minTimeout?: number;
}
export interface GetTimeoutSignalOptions {
    timeoutFactor?: number;
    signal?: AbortSignal;
}
export declare class AdaptiveTimeout {
    private readonly success;
    private readonly failure;
    private readonly next;
    private readonly metric?;
    private readonly timeoutMultiplier;
    private readonly failureMultiplier;
    private readonly minTimeout;
    constructor(init?: AdaptiveTimeoutInit);
    getTimeoutSignal(options?: GetTimeoutSignalOptions): AdaptiveTimeoutSignal;
    cleanUp(signal: AdaptiveTimeoutSignal): void;
}
//# sourceMappingURL=adaptive-timeout.d.ts.map