/**
 * Implements exponential moving average. Ported from `moving-average`.
 *
 * @see https://en.wikipedia.org/wiki/Moving_average#Exponential_moving_average
 * @see https://www.npmjs.com/package/moving-average
 */
export declare class MovingAverage {
    movingAverage: number;
    variance: number;
    deviation: number;
    forecast: number;
    private readonly timespan;
    private previousTime?;
    constructor(timespan: number);
    alpha(t: number, pt: number): number;
    push(value: number, time?: number): void;
}
//# sourceMappingURL=moving-average.d.ts.map